<?php

namespace Drupal\packagist\Form;

use Drupal\Core\Form\ConfigFormBase;
use Drupal\Core\Form\FormStateInterface;

/**
 * Class SettingsForm.
 */
class SettingsForm extends ConfigFormBase {

  /**
   * {@inheritdoc}
   */
  protected function getEditableConfigNames() {
    return [
      'packagist.settings',
    ];
  }

  /**
   * {@inheritdoc}
   */
  public function getFormId() {
    return 'packagist_settings';
  }

  /**
   * {@inheritdoc}
   */
  public function buildForm(array $form, FormStateInterface $form_state) {
    $config = $this->config('packagist.settings');
    $form['direct_execution'] = [
      '#type' => 'checkbox',
      '#title' => $this->t('Direct execution'),
      // @todo: add a warning into description
      '#description' => $this->t('Execute server-wrapper.sh script directly (not recommended).'),
      '#default_value' => $config->get('direct_execution'),
    ];
    return parent::buildForm($form, $form_state);
  }

  /**
   * {@inheritdoc}
   */
  public function submitForm(array &$form, FormStateInterface $form_state) {
    parent::submitForm($form, $form_state);

    $this->config('packagist.settings')
      ->set('direct_execution', $form_state->getValue('direct_execution'))
      ->save();
  }

}
